unit LogFilter;
interface
uses SysUtils, DBXPlatform, DBXTransport;

type
  TLogFilter = class(TTransportFilter)
  private
  protected
    function GetParameters: TDBXStringArray; override;
    function GetUserParameters: TDBXStringArray; override;
  public
    function GetParameterValue(const ParamName: UnicodeString): UnicodeString;
      override;
    function SetParameterValue(const ParamName: UnicodeString;
      const ParamValue: UnicodeString): Boolean; override;
    constructor Create; override;
    destructor Destroy; override;
    function ProcessInput(const Data: TBytes): TBytes; override;
    function ProcessOutput(const Data: TBytes): TBytes; override;
    function Id: UnicodeString; override;
  end;

const
  LogFilterName = 'Log';

implementation
uses
  Logging;

function TLogFilter.SetParameterValue(const ParamName,
  ParamValue: UnicodeString): Boolean;
begin
  Result := True;
end;

constructor TLogFilter.Create;
begin
  inherited Create;
end;

destructor TLogFilter.Destroy;
begin
  inherited Destroy;
end;

function TLogFilter.GetParameters: TDBXStringArray;
begin
end;

function TLogFilter.GetParameterValue(const ParamName: UnicodeString)
  : UnicodeString;
begin
end;

function TLogFilter.GetUserParameters: TDBXStringArray;
begin
end;

function TLogFilter.ProcessInput(const Data: TBytes): TBytes;
begin
  Result := Data; // log incoming data
  LogError(' Data size: '  + IntToStr(Length(Data)));
end;

function TLogFilter.ProcessOutput(const Data: TBytes): TBytes;
begin
  Result := Data; // log outgoing data
  LogError(' Data size: '  + IntToStr(Length(Data)));
end;

function TLogFilter.Id: UnicodeString;
begin
  Result := LogFilterName;
end;

initialization
  TTransportFilterFactory.RegisterFilter(LogFilterName, TLogFilter);
finalization
  TTransportFilterFactory.UnregisterFilter(LogFilterName);
end.
